// SNAKE
//  1.0
// (C) Red User, 2003
// Turbo C++ 3.0
// MS-DOS 6.22

// tcc.exe -d -f87 -2 -O snake.cpp

#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <bios.h>

#define BORD 177    //  ᨬ ࠬ
#define MAX 66      // ᨬ쭠    1
#define LENGTH 16   // 砫쭠  
#define PAUSE 3     // 砫쭠 প  ﬨ 

enum directiontype {up=72, left=75, right=77, down=80};

union stype {
  int integer;
  struct bytestype {
    unsigned b1: 8;
    unsigned b2: 8;
  } bytes;
};

text_info ti;

#define ucwidth  ti.screenwidth
#define ucheight ti.screenheight

struct point {
  unsigned char x, y;
  void init()
  {
    x=0;
    y=0;
  }
};

class Frame {
  protected:
  unsigned char ucbord;  //  ࠬ
  public:
  Frame(unsigned char bord=BORD): ucbord(bord) {}
  void show();
};

class Snake {
  protected:
  unsigned char pause;      // প  ﬨ 
  int l;
  directiontype direction;  // ࠢ  
  long int time;
  point psnake[MAX],        // ᨢ  न⠬ 祪,  
			    // 室 . ᫥ ᫥ 窨
			    // ( ) 室 ᨬ {0, y}
	tail;               // 窠,  ன 室
			    // 墮   ᫥ 
  public:
  Snake(): pause(PAUSE) { init(); }
  void init();
  void show(char ch='*');
  char move(directiontype newdirection);
};

class Snake_with_money: public Snake {
  protected:
  char level;                  // ஢
  int intamnt;                 // ࠭ 㬬 
  point money;                 // 窠,  ன 室 '$'
  void showlevel();
  void showamount();
  void hideamountandlevel();
  void showmoney(char ch='$');
  void genmoney();
  void shownewleveltext();
  void hidenewleveltext();
  public:
  Snake_with_money():
    Snake(), level(1), intamnt(0)
  {
    genmoney();
  }
  void init();
  char show();
  char newleveltext();
  char newlevel();
};

class Logo {
  protected:
  char **alogo,   // ᨢ ப, 뢮, 稭  3- ப ࠭
       *end,      // ப, 뢮  ࠭ ( 3- ப ᭨)
       m,         // ᫮ ப ᨢ alogo
       high;      // ᫮ ப ᨢ alogo, 뢮
		  //  襭 મ
  public:
  Logo(char **algo, char chm, char chigh, char *chend):
    alogo(algo), m(chm), high(chigh), end(chend) {}
  void show();
};

class Menu: public Logo {
  protected:
  char **link,    // ᨢ ப  ﬨ 㭪⮢ 
       n,         // ᫮ 㭪⮢ 
       active;    // ⨢ 㭪 
  void show();
  public:
  Menu(char **lnk, char chn,
       char **algo, char chm, char chigh, char *chend):
    link(lnk), n(chn), active(0),
    Logo(algo, chm, chigh, chend) {}
  void run();
};

char pse(long int intpause)
{
  char chpause=0;
  stype s;
  long int time=biostime(0, 0);

  while((labs(biostime(0, 0)-time)<intpause)||chpause) {
    if(bioskey(1)) {
      s.integer=bioskey(0);
      switch(s.bytes.b1) {
	case 27:  return 1;
	case 'P':
	case 'p': chpause?(chpause=0):(chpause=1);
      }
    }
  }
  return 0;
}

void game()
{
  char chpause=0;
  stype s;
  directiontype newdirection=right;
  Frame frame;
  Snake_with_money snake;

  clrscr();
  frame.show();
  if(snake.newleveltext()) return;
  for(;;) {
    if(bioskey(1)) {
      s.integer=bioskey(0);
      switch(s.bytes.b1) {
	case 0:   switch(s.bytes.b2) {
		    case 72:
		    case 75:
		    case 77:
		    case 80:  if(!chpause)
				newdirection=(directiontype)s.bytes.b2;
		  }
		  break;
	case 27:  return;
	case 'P':
	case 'p': chpause?(chpause=0):(chpause=1);
      }
    }
    if(chpause) continue;
    if(snake.move(newdirection)) {
      pse(60);
      return;
    }
    if(snake.show()) {
      if(snake.newlevel())
	return;
      newdirection=right;
    }
  }
}

void mainf()
{
  char *m[]={"", "室"};
  char *snakelogo[]={" ****  *    *   **   **   * ******",
		     "*    * *    *  *  *   *   *  *   *",
		     "*      **   * *    *  *  *   *",
		     " *     ***  * *    *  * *    *  *",
		     "  **   * ** * ******  **     ****",
		     "    *  *  *** *    *  * *    *  *",
		     "     * *   ** *    *  *  *   *",
		     "*    * *    * *    *  *   *  *   *",
		     " ****  *    * *    * **   * ******",
		     "",
		     "             1.0"};
  char end[]={"(C) Red User, 2003"};
  Menu menu(m, 2, snakelogo, 11, 9, end);

  clrscr();
  menu.run();
}

void main()
{
  directvideo=1;
  gettextinfo(&ti);
  _setcursortype(_NOCURSOR);
  mainf();
  clrscr();
  _setcursortype(_NORMALCURSOR);
}

void Frame::show()
{
  char j;
  for(j=0; j<ucwidth; j++)
    putch(ucbord);
  for(j=0; j<(ucheight-3); j++) {
    putch(ucbord);
    gotoxy(ucwidth, wherey());
    putch(ucbord);
  }
  for(j=0; j<ucwidth; j++)
    putch(ucbord);
  gotoxy(ucwidth-19, ucheight);
  cputs("P 㧠  Esc 室");
}

void Snake::init()
{
  tail.init();
  for(l=0; l<LENGTH; l++) {
    psnake[l].x=ucwidth/2-LENGTH+l;
    psnake[l].y=ucheight/2;
  }
  psnake[l].x=0;
  direction=right;
  time=biostime(0, 0);
}

void Snake::show(char ch)
{
  if(tail.x) {
    gotoxy(tail.x, tail.y);
    putch(' ');
  }
  l=0;
  while(psnake[l].x) {
    gotoxy(psnake[l].x, psnake[l].y);
    putch(ch);
    l++;
  }
}

char Snake::move(directiontype newdirection)
{
  if(labs(biostime(0, 0)-time)<pause)
    return 0;
  tail=psnake[0];
  switch(newdirection) {
    case up:    if(direction!=down)
		  direction=up;
		break;
    case left:  if(direction!=right)
		  direction=left;
		break;
    case right: if(direction!=left)
		  direction=right;
		break;
    case down:  if(direction!=up)
		  direction=down;
  }
  for(l=1; psnake[l].x; l++)
    psnake[l-1]=psnake[l];
  switch(direction) {
    case left:  psnake[--l].x--;
		if((psnake[l].x<2)||(psnake[l].x>ucwidth-1))
		  return 1;
		break;
    case right: psnake[--l].x++;
		if((psnake[l].x<2)||(psnake[l].x>ucwidth-1))
		  return 1;
		break;
    case up:    psnake[--l].y--;
		if((psnake[l].y<2)||(psnake[l].y>ucheight-2))
		  return 1;
		break;
    case down:  psnake[--l].y++;
		if((psnake[l].y<2)||(psnake[l].y>ucheight-2))
		  return 1;
  }
  for(int j=0; j<l; j++)
    if((psnake[l].x==psnake[j].x)&&(psnake[l].y==psnake[j].y))
      return 1;
  time=biostime(0, 0);
  return 0;
}

void Snake_with_money::showlevel()
{
  char output[7]=". ";
  char string[3];
  gotoxy(11, ucheight);
  itoa(level, string, 16);
  cputs(strcat(output,string));
}

void Snake_with_money::showamount()
{
  char string[6];
  gotoxy(3, ucheight);
  itoa(intamnt, string, 10);
  cputs(string);
  putch('$');
}

void Snake_with_money::hideamountandlevel()
{
  gotoxy(3, ucheight);
  for(int i=0; i<14; i++)
    putch(' ');
}

void Snake_with_money::showmoney(char ch)
{
  gotoxy(money.x, money.y);
  putch(ch);
}

void Snake_with_money::genmoney()
{
  randomize();
  do {
    money.x=random(ucwidth-2)+2;
    money.y=random(ucheight-3)+2;
    for(l=0; psnake[l].x; l++)
      if((psnake[l].x==money.x)&&(psnake[l].y==money.y))
	break;
  } while(psnake[l].x);
}

char Snake_with_money::newlevel()
{
  if(pse(30)) return 1;
  (pause-1)?(pause--, level++):(pause=PAUSE, level=1, intamnt=0);
  showmoney(' ');
  Snake::show(' ');
  hideamountandlevel();
  init();
  if(newleveltext()) return 1;
  Snake::show();
  showamount();
  showlevel();
  showmoney();
  if(pse(30)) return 1;
  return 0;
}

void Snake_with_money::shownewleveltext()
{
  char newlev[11]="஢ ";
  char string[3];

  itoa(level, string, 16);
  strcat(newlev, string);
  gotoxy((ucwidth-strlen(newlev))/2+1, ucheight/2);
  cputs(newlev);
}

void Snake_with_money::hidenewleveltext()
{
  gotoxy((ucwidth-11)/2+1, ucheight/2);
  for(int p=0; p<11; p++)
    putch(' ');
}

char Snake_with_money::newleveltext()
{
  shownewleveltext();
  if(pse(30)) return 1;
  hidenewleveltext();
  return 0;
}

void Snake_with_money::init()
{
  Snake::init();
  genmoney();
}

char Snake_with_money::show()
{
  Snake::show();
  l--;
  if((psnake[l].x==money.x)&&(psnake[l].y==money.y)) {
    intamnt++;
    if((l+1)==MAX-1)
      return 1;
    else {
      psnake[l+1]=psnake[l];
      psnake[l+2].x=0;
      genmoney();
    }
  }
  showamount();
  showlevel();
  showmoney();
  return 0;
}

void Logo::show()
{
  int i;
  char x=(ucwidth-strlen(alogo[0]))/2+1,
       y=3;

  highvideo();
  for(i=0; i<m; i++) {
    if(i==high) normvideo();
    gotoxy(x, y+i);
    cputs(alogo[i]);
  }
  gotoxy((ucwidth-strlen(end))/2+1, ucheight-2);
  cputs(end);
}

void Menu::show()
{
  char y=ucheight-n-4;

  Logo::show();
  for(int i=0; i<n; i++) {
    gotoxy((ucwidth-strlen(link[i]))/2+1, y+i);
    if(i==active) highvideo();
    cputs(link[i]);
    normvideo();
  }
}

void Menu::run()
{
  stype s;

  for(;;) {
    show();
    if(bioskey(1)) {
      s.integer=bioskey(0);
      switch(s.bytes.b1) {
	case 0:   switch(s.bytes.b2) {
		    case 72:  if(active) active--;
			      break;
		    case 80:  if(active<(n-1)) active++;
		  }
		  break;
	case 13:  if(active)
		    return;
		  else {
		    game();
		    clrscr();
		  }
      }
    }
  }
}









